
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ExpensesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const expenses = await db.expenses.create(
            {
                id: data.id || undefined,
        
        reference: data.reference
        ||
        null
            ,
            
        category: data.category
        ||
        null
            ,
            
        expense_date: data.expense_date
        ||
        null
            ,
            
        amount: data.amount
        ||
        null
            ,
            
        payment_method: data.payment_method
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await expenses.setSupplier( data.supplier || null, {
            transaction,
        });
        
        await expenses.setCreated_by_user( data.created_by_user || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.expenses.getTableName(),
                belongsToColumn: 'receipt_files',
                belongsToId: expenses.id,
            },
            data.receipt_files,
            options,
        );
        

        return expenses;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const expensesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                reference: item.reference
            ||
            null
            ,
            
                category: item.category
            ||
            null
            ,
            
                expense_date: item.expense_date
            ||
            null
            ,
            
                amount: item.amount
            ||
            null
            ,
            
                payment_method: item.payment_method
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const expenses = await db.expenses.bulkCreate(expensesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < expenses.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.expenses.getTableName(),
                    belongsToColumn: 'receipt_files',
                    belongsToId: expenses[i].id,
                },
                data[i].receipt_files,
                options,
            );
        }
        

        return expenses;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const expenses = await db.expenses.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.reference !== undefined) updatePayload.reference = data.reference;
        
        
        if (data.category !== undefined) updatePayload.category = data.category;
        
        
        if (data.expense_date !== undefined) updatePayload.expense_date = data.expense_date;
        
        
        if (data.amount !== undefined) updatePayload.amount = data.amount;
        
        
        if (data.payment_method !== undefined) updatePayload.payment_method = data.payment_method;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await expenses.update(updatePayload, {transaction});

        
        
        if (data.supplier !== undefined) {
            await expenses.setSupplier(
              
              data.supplier,
              
              { transaction }
            );
        }
        
        if (data.created_by_user !== undefined) {
            await expenses.setCreated_by_user(
              
              data.created_by_user,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.expenses.getTableName(),
                belongsToColumn: 'receipt_files',
                belongsToId: expenses.id,
            },
            data.receipt_files,
            options,
        );
        

        return expenses;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const expenses = await db.expenses.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of expenses) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of expenses) {
                await record.destroy({transaction});
            }
        });


        return expenses;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const expenses = await db.expenses.findByPk(id, options);

        await expenses.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await expenses.destroy({
            transaction
        });

        return expenses;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const expenses = await db.expenses.findOne(
            { where },
            { transaction },
        );

        if (!expenses) {
            return expenses;
        }

        const output = expenses.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.cash_movements_expense = await expenses.getCash_movements_expense({
            transaction
        });
        
        
        
        
        
        
        
        
        
        output.supplier = await expenses.getSupplier({
            transaction
        });
        
        
        output.receipt_files = await expenses.getReceipt_files({
            transaction
        });
        
        
        output.created_by_user = await expenses.getCreated_by_user({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.suppliers,
        as: 'supplier',
        
        where: filter.supplier ? {
          [Op.or]: [
            { id: { [Op.in]: filter.supplier.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.supplier.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'created_by_user',
        
        where: filter.created_by_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.created_by_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.created_by_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'receipt_files',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.reference) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'expenses',
                        'reference',
                        filter.reference,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'expenses',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.expense_dateRange) {
                const [start, end] = filter.expense_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expense_date: {
                    ...where.expense_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expense_date: {
                    ...where.expense_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.amountRange) {
                const [start, end] = filter.amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.category) {
                where = {
                    ...where,
                category: filter.category,
            };
            }
            
            if (filter.payment_method) {
                where = {
                    ...where,
                payment_method: filter.payment_method,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.expenses.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'expenses',
                        'reference',
                        query,
                    ),
                ],
            };
        }

        const records = await db.expenses.findAll({
            attributes: [ 'id', 'reference' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['reference', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.reference,
        }));
    }

    
};

